' Set FBIde Compil & Run v.<VER> by Eric LEQUIEN on 27th of August 2006 
' CONTACT : through www.freebasic.net/forum ; my alias being 'eanon' there
' IMPORTANT : take care to adjust the FBIDE constant to your own configuration 
' MORE INFO in joined readme.txt

option explicit

declare function GetPrivateProfileString lib "Kernel32" alias "GetPrivateProfileStringA" _
   (byval lpApplicationName as string, byval lpKeyName as string, byval lpDefault as string, _
   byval lpReturnedString as string, byval nSize as long, byval lpFileName as string) as long
declare function WritePrivateProfileString lib "Kernel32" alias "WritePrivateProfileStringA" _
   (byval lpApplicationName as string, byval lpKeyName as string, byval lpString as string, _
   byval lpFileName as string) as long

#define FALSE 0
#define TRUE NOT FALSE

const VER = "0.1 Beta"
const CRLF = chr(13) & chr(10)
const QUOT = chr(34)

dim strMsg as string, strSection as string, strKey as string, nIdx as integer, _
    strValue as string, strBuffer as string, nRet as integer, nPos as integer
    
dim nParams as integer = 3, bNoPause as integer
dim arTag(1 to 2) as string => {"<$fbc>", "<$file>"}

on error goto ErrHandler

'Configuration (feel free to adjust to your own context)
const FBIDEINI = "E:\FreeBASIC\FBIde\IDE\prefs_win32.ini"

'Init. UI
cls
locate 0,0,0
strMsg = "Set FBIde Compil & Run " & VER & " by ELN on 08/28/06 - Open Source Freeware"
print strMsg & CRLF & string(len(strMsg), 196) & CRLF _
      & ".Usage : setfbidecompilrun " & QUOT & "new_fbc_cmd" & QUOT _
      & " [" & QUOT & "new_run_cmd" & QUOT & "] [/nopause]" & CRLF _
      & "         with : new_fbc_cmd w/o any escaped quotation marks inside" & CRLF _
      & "                new_run_cmd with / or \\ if need to enter a path" & CRLF _
      & "                /nopause to close console at the end unless error msg" & CRLF _
      & string(len(strMsg), 196) & CRLF & CRLF & ".FBIde ini file : '" & FBIDEINI & "'"

'Get current values from .ini file (also, do check if chance to be the right file)
strBuffer = space(255)
strSection = "compiler"
strKey = "command"
nRet = GetPrivateProfileString(strSection, strKey, "", strBuffer, Len(strBuffer), FBIDEINI)
strValue = left(strBuffer, nRet)
if nRet = 0 then error 10
print ".Compiler command : '" & strValue & "'"

strKey = "runprototype"
nRet = GetPrivateProfileString(strSection, strKey, "", strBuffer, Len(strBuffer), FBIDEINI)
strValue = left(strBuffer, nRet)
if nRet = 0 then error 15
print ".Run command : '" & strValue & "'" & CRLF

'Get new compiler value as 1st param, adjust missing escaped quotation marks, then write-it
'WARNING : this part will generate error when ran from within FBIde because FBIde interprets $file !
strValue = command$(1)
if strValue = "" then error 20
for nIdx = 1 to ubound(arTag)
   nPos = instr(strValue, arTag(nIdx))
   if nPos <> 0 then
      strValue = left(strValue, nPos - 1) & "\" & QUOT & arTag(nIdx) & "\" & QUOT _
                  & right(strValue, len(strValue) - nPos - len(arTag(nIdx)) + 1)
   else
      error 30
   end if
next
print ".Wished compiler cmd : '" & strValue & "'";
strValue = QUOT & strValue & QUOT

strKey = "command"
nRet = WritePrivateProfileString(strSection, strKey, strValue, FBIDEINI)
if nRet = 0 then print : error 40
print " => successfully updated !"

'Search for eventual new run value as 2nd param, then adjust missing escaped quotation marks & write-it
strValue = command$(2)
if strValue <> "" and left(strValue, 1) <> "/" then 
   nPos = instr(strValue, arTag(2))
   if nPos <> 0 then
      strValue = left(strValue, nPos - 1) & "\" & QUOT & arTag(2) & "\" & QUOT _
                  & right(strValue, len(strValue) - nPos - len(arTag(2)) + 1)
   end if
   if instr(strValue, "<$param>") = 0 then error 35
   print ".Wished run cmd : '" & strValue & "'";
   strValue = QUOT & strValue & QUOT
   
   strKey = "runprototype"
   nRet = WritePrivateProfileString(strSection, strKey, strValue, FBIDEINI)
   if nRet = 0 then print : error 40
   print " => successfully updated !"
else
   print ".No request about run cmd : will remain unchanged !"
end if

'Search for optional unique switch (param w/ variable position)
bNoPause = FALSE
for nIdx = 2 to nParams
   if lcase(command$(nIdx)) = "/nopause" then bNoPause = TRUE
next

'Termination
print ".You need to restart FBIde if running !"
Ending:
on error goto 0
if not bNoPause then sleep
end

'Errors
ErrHandler:
strMsg = ".Error "
select case Err
   case 10
      strMsg = strMsg & ": cannot get current compiler command value in given FBIde ini file" & CRLF _
               & "         (adjust FBIde's ini path in FBIDEINI constant of source file)
   case 15
      strMsg = strMsg & ": cannot get current run command value in given FBIde ini file"
   case 20
      strMsg = strMsg & ": not any compiler cmd in cmdline (should be passed as 1st argument)"
   case 30
      strMsg = strMsg & ": invalid compiler command (should contain " & arTag(1) & " & " & arTag(2) & ")"
   case 35
      strMsg = strMsg & ": invalid run command (should contain <$param>)"
   case 40
      strMsg = strMsg & ": failed to write the new compiler command in the FBIde ini file"
   case else
      strMsg = strMsg & "#" & Err
end select
print strMsg
goto Ending
